import { EnumHandleType } from './enums';
import * as _ from 'lodash';
var translateValueToHandleLeftPositionPx = function (domain, scss, type, value) {
    var result = (value - domain.domainMin) / (domain.domainMax - domain.domainMin) * scss.widthPx;
    if (type == EnumHandleType.Right)
        result -= scss.handleWidthPx;
    return _.isNaN(result) ? 0 : result;
};
/**
 * Translates length provided in pixels to an equivalent expressed in domain units
 */
var expressLengthPxInDomain = function (domain, scss, lengthPx) {
    return (lengthPx / scss.widthPx) * (domain.domainMax - domain.domainMin);
};
var expressDomainLengthInPx = function (domain, scss, length) {
    return _.reduce([(length / (domain.domainMax - domain.domainMin) * scss.widthPx)], function (sum, el) { return _.isNaN(el) ? 0 : el; }, 0);
};
export var calculations = {
    translateValueToHandleLeftPositionPx: translateValueToHandleLeftPositionPx,
    expressLengthPxInDomain: expressLengthPxInDomain,
    expressDomainLengthInPx: expressDomainLengthInPx
};
//# sourceMappingURL=calculations.js.map