var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as _ from 'lodash';
import * as React from 'react';
import { EnumTimeSeriesType } from '../../state/enums';
import { renderLineTimeSeries } from './line-time-series';
import { renderDotTimeSeries } from './dot-time-series';
var TimeSeries = /** @class */ (function (_super) {
    __extends(TimeSeries, _super);
    function TimeSeries(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {};
        return _this;
    }
    TimeSeries.prototype.renderSvgPrimitives = function () {
        var _this = this;
        var result = [];
        _.each(this.props.chartTimeSeries, function (ts) {
            var ctx = {
                ts: ts,
                xScale: _this.props.xScale,
                yScale: _this.props.yScale
            };
            switch (ts.type) {
                case EnumTimeSeriesType.Line:
                    result.push(renderLineTimeSeries(ctx));
                    break;
                case EnumTimeSeriesType.Dots:
                    result.push(renderDotTimeSeries(ctx, 2));
                    break;
                case EnumTimeSeriesType.DottedLine:
                    result.push(renderLineTimeSeries(ctx));
                    result.push(renderDotTimeSeries(ctx, 2));
                    break;
            }
        });
        return result;
    };
    TimeSeries.prototype.render = function () {
        return (React.createElement("g", null, this.renderSvgPrimitives()));
    };
    return TimeSeries;
}(React.Component));
export { TimeSeries };
//# sourceMappingURL=index.js.map