import * as _ from 'lodash';
import * as dateFns from 'date-fns';
var debug = false;
export var EnumRawCsvFormat;
(function (EnumRawCsvFormat) {
    EnumRawCsvFormat[EnumRawCsvFormat["DateTimeThenValue"] = 0] = "DateTimeThenValue";
    EnumRawCsvFormat[EnumRawCsvFormat["UnixTimeThenValue"] = 1] = "UnixTimeThenValue";
})(EnumRawCsvFormat || (EnumRawCsvFormat = {}));
var extractUnixTimePoints = function (csvRows, config) {
    return _.map(csvRows, function (row) {
        return {
            unix: (function () {
                switch (config.rawFormat) {
                    case EnumRawCsvFormat.UnixTimeThenValue:
                        return parseInt(row[config.timeStampColumnName]);
                    case EnumRawCsvFormat.DateTimeThenValue:
                        return dateFns.parse(row[config.timeStampColumnName]).getTime();
                }
            })(),
            value: parseFloat(row[config.valueColumnName])
        };
    });
};
export var csvLoadingCalculations = {
    extractUnixTimePoints: extractUnixTimePoints
};
//# sourceMappingURL=calculations.js.map