import * as _ from 'lodash';
import * as Papa from 'papaparse';
import { StartedProcessingCsvAction, ReceivedCsvChunkAction, FinishedProcessingCsvAction } from './actions';
var loadCsv = function (url, useStreaming) {
    if (useStreaming === void 0) { useStreaming = false; }
    return function (dispatch) {
        dispatch(_.toPlainObject(new StartedProcessingCsvAction()));
        Papa.parse(url, {
            download: true,
            worker: false,
            header: true,
            skipEmptyLines: true,
            chunk: useStreaming ?
                function (results) { return dispatch(_.toPlainObject(new ReceivedCsvChunkAction(results.data))); } :
                undefined,
            complete: function (results) { return dispatch(_.toPlainObject(new FinishedProcessingCsvAction(_.isObject(results) ? results.data : []))); }
        });
    };
};
export { loadCsv };
//# sourceMappingURL=effects.js.map