var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as _ from 'lodash';
import * as React from 'react';
import { EnumHandleType } from '../hp-slider/enums';
import { HpSlider } from '../hp-slider';
import { EnumHpTimeSeriesChartMode, HpTimeSeriesChart } from '../hp-time-series-chart';
/**
 * This statefull component aggregates HpTimeSeriesChart and HpSlider components, acting as an example how to use them.
 * It can be used as a production-ready solution as well.
 * For non-Redux usage please HpTimeSeriesScrollerWrapper.
 */
var HpTimeSeriesScroller = /** @class */ (function (_super) {
    __extends(HpTimeSeriesScroller, _super);
    function HpTimeSeriesScroller(props) {
        var _this = _super.call(this, props) || this;
        _this.getDomain = function () {
            return { domainMin: _this.props.chartState.dateRangeUnixFrom, domainMax: _this.props.chartState.dateRangeUnixTo };
        };
        _this._getChartInSliderDimensions = function () {
            return {
                heightPx: _this.props.sliderScss.heightPx,
                widthPx: _this.props.timeSeriesChartScss.widthPx,
                paddingBottomPx: 0,
                paddingLeftPx: 0,
                paddingRightPx: 0,
                paddingTopPx: 0
            };
        };
        _this.resizeCallback = function () {
            if (_.isObject(_this.parentElement) && _.isBoolean(_this.props.fitToParentSize) && _this.props.fitToParentSize) {
                _this.setState({
                    sliderScss: _.extend(_this.state.sliderScss, {
                        widthPx: _this.parentElement.clientWidth
                    }),
                    timeSeriesChartScss: _.extend(_this.state.timeSeriesChartScss, {
                        widthPx: _this.parentElement.clientWidth,
                        heightPx: _this.parentElement.clientHeight
                    })
                });
            }
        };
        _this.state = {
            windowUnixFrom: props.chartState.dateRangeUnixFrom,
            windowUnixTo: props.chartState.dateRangeUnixTo,
            chartState: props.chartState,
            sliderScss: props.sliderScss,
            timeSeriesChartScss: props.timeSeriesChartScss
        };
        return _this;
    }
    HpTimeSeriesScroller.prototype.componentWillReceiveProps = function (nextProps, nextContext) {
        this.setState(_.extend({}, {
            chartState: nextProps.chartState,
            sliderScss: _.extend(nextProps.sliderScss, _.isObject(this.parentElement) && _.isBoolean(this.props.fitToParentSize) && this.props.fitToParentSize ? {
                widthPx: this.parentElement.clientWidth
            } : {}),
            timeSeriesChartScss: _.extend(nextProps.timeSeriesChartScss, _.isObject(this.parentElement) && _.isBoolean(this.props.fitToParentSize) && this.props.fitToParentSize ? {
                widthPx: this.parentElement.clientWidth,
                heightPx: this.parentElement.clientHeight
            } : {}),
            windowUnixFrom: nextProps.chartState.windowUnixFrom,
            windowUnixTo: nextProps.chartState.windowUnixTo
        }));
    };
    HpTimeSeriesScroller.prototype.componentWillMount = function () {
        this.resizeCallback();
    };
    HpTimeSeriesScroller.prototype.componentDidMount = function () {
        window.addEventListener("resize", this.resizeCallback);
        this.resizeCallback();
    };
    HpTimeSeriesScroller.prototype.componentWillUnmount = function () {
        window.removeEventListener("resize", this.resizeCallback);
    };
    HpTimeSeriesScroller.prototype.render = function () {
        var _this = this;
        return (React.createElement("div", { ref: function (el) {
                if (_.isObject(el))
                    _this.parentElement = el.parentElement;
            } },
            React.createElement(HpTimeSeriesChart, { scss: this.state.timeSeriesChartScss, state: this.state.chartState }),
            React.createElement("br", null),
            (_.isBoolean(this.props.displaySlider) ? this.props.displaySlider : true) &&
                React.createElement(HpSlider, { domain: this.getDomain(), handleValues: { left: this.state.windowUnixFrom, right: this.state.windowUnixTo }, scss: this.props.sliderScss, displayDragBar: true, handleMoved: function (value, type) {
                        var newUnixFrom = _this.state.windowUnixFrom;
                        var newUnixTo = _this.state.windowUnixTo;
                        switch (type) {
                            case EnumHandleType.Left:
                                newUnixFrom = _.isNumber(value) ? value : 0;
                                break;
                            case EnumHandleType.Right:
                                newUnixTo = _.isNumber(value) ? value : 0;
                                break;
                            case EnumHandleType.DragBar:
                                newUnixFrom = _.isArray(value) ? value[0] : 0;
                                newUnixTo = _.isArray(value) ? value[1] : 0;
                                break;
                        }
                        _this.setState({
                            windowUnixFrom: newUnixFrom,
                            windowUnixTo: newUnixTo,
                            chartState: _.extend(_this.state.chartState, {
                                windowUnixFrom: newUnixFrom,
                                windowUnixTo: newUnixTo
                            })
                        });
                    } },
                    React.createElement(HpTimeSeriesChart, { scss: this._getChartInSliderDimensions(), state: this.props.chartState, mode: EnumHpTimeSeriesChartMode.SliderEmbedded }))));
    };
    return HpTimeSeriesScroller;
}(React.Component));
export { HpTimeSeriesScroller };
//# sourceMappingURL=index.js.map